package dev.micle.totemofreviving.data;

import dev.micle.totemofreviving.item.crafting.ExtendedShapedRecipeBuilder;
import dev.micle.totemofreviving.setup.ModItems;
import dev.micle.totemofreviving.setup.ModRecipes;
import net.minecraft.data.DataGenerator;
import net.minecraft.data.recipes.FinishedRecipe;
import net.minecraft.data.recipes.RecipeProvider;
import net.minecraft.world.item.Items;

import javax.annotation.ParametersAreNonnullByDefault;
import java.util.function.Consumer;

public class ModRecipeProvider extends RecipeProvider {
    public ModRecipeProvider(DataGenerator generator) {
        super(generator);
    }
	
    @Override
	@ParametersAreNonnullByDefault
    protected void buildCraftingRecipes(Consumer<FinishedRecipe> consumer) {
		ExtendedShapedRecipeBuilder.shaped(ModRecipes.TOTEM_RECIPE.get(), ModItems.STRAW_TOTEM.get())
				.define('W', Items.WHEAT)
				.define('|', Items.STICK)
				.define('S', Items.STRING)
				.define('N', Items.IRON_NUGGET)
				.pattern("NSN")
				.pattern("NWN")
				.pattern("N|N")
				.unlockedBy("has_item", has(Items.WHEAT))
				.save(consumer);
		ExtendedShapedRecipeBuilder.shaped(ModRecipes.TOTEM_RECIPE.get(), ModItems.IRON_TOTEM.get())
				.define('B', Items.IRON_BLOCK)
				.define('E', Items.EMERALD)
				.define('I', Items.IRON_INGOT)
				.pattern(" E ")
				.pattern("IBI")
				.pattern(" I ")
				.unlockedBy("has_item", has(Items.EMERALD))
				.save(consumer);
		ExtendedShapedRecipeBuilder.shaped(ModRecipes.TOTEM_RECIPE.get(), ModItems.DIAMOND_TOTEM.get())
				.define('T', Items.TOTEM_OF_UNDYING)
				.define('D', Items.DIAMOND)
				.define('E', Items.ENDER_PEARL)
				.pattern("EDE")
				.pattern("DTD")
				.pattern("EDE")
				.unlockedBy("has_item", has(Items.TOTEM_OF_UNDYING))
				.save(consumer);
		ExtendedShapedRecipeBuilder.shaped(ModRecipes.TOTEM_RECIPE.get(), ModItems.NETHERITE_TOTEM.get())
				.define('T', ModItems.DIAMOND_TOTEM.get())
				.define('N', Items.NETHERITE_SCRAP)
				.define('G', Items.GOLD_INGOT)
				.define('B', Items.NETHER_BRICK)
				.pattern("BNB")
				.pattern("NTN")
				.pattern("BGB")
				.unlockedBy("has_item", has(Items.NETHERITE_SCRAP))
				.save(consumer);
		
		ExtendedShapedRecipeBuilder.shaped(ModRecipes.CHARGE_RECIPE.get(), ModItems.STRAW_CHARGE.get())
				.define('E', Items.EMERALD)
				.define('W', Items.WHEAT)
				.define('N', Items.IRON_NUGGET)
				.pattern("NWN")
				.pattern("WEW")
				.pattern("NWN")
				.unlockedBy("has_item", has(ModItems.STRAW_TOTEM.get()))
				.save(consumer);
		ExtendedShapedRecipeBuilder.shaped(ModRecipes.CHARGE_RECIPE.get(), ModItems.IRON_CHARGE.get())
				.define('E', Items.EMERALD)
				.define('I', Items.IRON_INGOT)
				.define('N', Items.IRON_NUGGET)
				.pattern("NIN")
				.pattern("IEI")
				.pattern("NIN")
				.unlockedBy("has_item", has(ModItems.IRON_TOTEM.get()))
				.save(consumer);
		ExtendedShapedRecipeBuilder.shaped(ModRecipes.TOTEM_RECIPE.get(), ModItems.DIAMOND_CHARGE.get())
				.define('E', Items.EMERALD)
				.define('D', Items.DIAMOND)
				.define('I', Items.IRON_INGOT)
				.define('P', Items.ENDER_PEARL)
				.pattern("IDI")
				.pattern("PEP")
				.pattern("IDI")
				.unlockedBy("has_item", has(ModItems.DIAMOND_TOTEM.get()))
				.save(consumer);
		ExtendedShapedRecipeBuilder.shaped(ModRecipes.CHARGE_RECIPE.get(), ModItems.NETHERITE_CHARGE.get())
				.define('C', ModItems.DIAMOND_CHARGE.get())
				.define('N', Items.NETHERITE_SCRAP)
				.define('G', Items.GOLD_INGOT)
				.pattern("GNG")
				.pattern("NCN")
				.pattern("GNG")
				.unlockedBy("has_item", has(ModItems.NETHERITE_TOTEM.get()))
				.save(consumer);
    }
}
