package dev.micle.totemofreviving.item.charge;

import dev.micle.totemofreviving.TotemOfReviving;
import dev.micle.totemofreviving.config.Config;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.TextComponent;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Rarity;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.world.level.Level;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;

import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;
import java.util.List;

public class ChargeItem extends Item {
	public ChargeItem() {
		this(Rarity.COMMON);
	}
	
	public ChargeItem(Rarity rarity) {
		super(new Properties().tab(TotemOfReviving.ITEM_GROUP).stacksTo(64).rarity(rarity));
	}
	
	@Override
	@OnlyIn(Dist.CLIENT)
	@ParametersAreNonnullByDefault
	public void appendHoverText(ItemStack stack, @Nullable Level world, List<Component> tooltip, TooltipFlag tooltipFlag) {
		if (isEnabled(stack)) {
			tooltip.add(new TextComponent(ChatFormatting.WHITE + "Used for charging its corresponding totem."));
		} else {
			tooltip.add(new TextComponent(ChatFormatting.RED + "Totem is disabled!"));
		}
		super.appendHoverText(stack, world, tooltip, tooltipFlag);
	}
	
	public static boolean isEnabled(ItemStack stack) {
		Item item = stack.getItem();
		if (item instanceof StrawChargeItem) { return Config.Server.getStrawTotemConfig().getIsEnabled(); }
		if (item instanceof IronChargeItem) { return Config.Server.getIronTotemConfig().getIsEnabled(); }
		if (item instanceof DiamondChargeItem) { return Config.Server.getDiamondTotemConfig().getIsEnabled(); }
		if (item instanceof NetheriteChargeItem) { return Config.Server.getNetheriteTotemConfig().getIsEnabled(); }
		return false;
	}
}
